#! /bin/sh

. masktab.data

cat >masktab.c <<@
/* This file is automatically generated. Do not edit! */

struct masktab {
    char *name;
    int m1,m2,cap;
} maskname[]={
@

sm=`grep '#define SM1_' sysmask.h | awk '{print $2}' | \
	sed 's/SM1_//' | sort | \
	awk '{print "{\""tolower($1)"\",SM1_"$1",SM2_"$1",0},"}'`

cap=`grep -E '^#define CAP_[A-Z_]*[[:space:]]+[0-9]+$' /usr/include/linux/capability.h |\
	awk '{print "{\""tolower($2)"\",0,0,(1<<"$3")},"}'`

echo "$sm
$cap
{\"cap_all\",0,0,0xFFFFFFFF}," | grep . | sort -t\" -k2 >>masktab.c

cat >>masktab.c <<@
};

/* val must be the second item after name */
struct triggertab {
     char *name;
     int val;
} triggers[]={
@

tr1=`grep '^[[:space:]]*#define[[:space:]]*__NR_' syscalls.h | \
	sed 's/__NR__/__NR_/' | \
	sed 's/__NR_//' | \
	awk '{print "{\""$2"\",__NR_"$2"},"}'`

tr2=`grep '^[[:space:]]*#define[[:space:]]*SYS_' /usr/include/linux/net.h | \
	sed 's/SYS_//' | \
	awk '{print "{\""tolower($2)"\",SMT_SOCKET+SYS_"$2"},"}'`

tr3=`grep '^[[:space:]]*#define[[:space:]]*SMT_' sysmask.h | \
	sed 's/SMT_//' | \
	awk '$3>=20000 {print "{\""tolower($2)"\","$3"},"}'`

echo "$tr1
$tr2
$tr3
{\"backup\",CALL_BACKUP},
{\"daemon\",SMKD_EXCEPT-1}," | grep . | sort -t\" -k2 >>masktab.c

cat >>masktab.c <<@
};

char *defs[127];
enum{
@

test=`echo "$smkdef" | awk 'NF==2 {print}' | sort | uniq | \
	grep -c .`

if [ "$test" -gt 126 ]; then
 rm -f masktab.c
 echo "masktab.sh: Too many name declarations ($test)! Maximum is 127."
 exit 1
fi

list=`echo "$smkdef" | grep . | sort | uniq`

echo "$list" | awk 'NF==2 {print "defname_"$1","}' >>masktab.c

cat >>masktab.c <<@
};

@

echo "$list" | awk 'NF==2 {print "#define defs_"$1" defs[defname_"$1"]"}' >>masktab.c

cat >>masktab.c <<@

struct cdeftab {
     char *name;
     int val;
     int type;
} cdef[]={
@

echo "$smkdef" | grep . | sort | uniq | \
	awk 'NF==2 {print "{\""$1"\",defname_"$1",DEFTYPE_"toupper($2)"},"};
	     NF==3 {print "{\""$1"\",defname_"$3",DEFTYPE_"toupper($2)"},"};' >>masktab.c

cat >>masktab.c <<@
};

struct fnametab {
	char *name;
	int val;
} fnametab[]={
@

grep '#define NAME_' smk.h | awk '{print $2}' | \
	sed 's/NAME_//' | sort | uniq | \
	awk '{print "{\""tolower($1)"\",NAME_"$1"},"}' >>masktab.c

cat >>masktab.c <<@
};

#define maskcnt (sizeof(maskname)/sizeof(maskname[0]))
#define trcnt (sizeof(triggers)/sizeof(triggers[0]))
#define fnamecnt (sizeof(fnametab)/sizeof(fnametab[0]))

@

awk 'BEGIN {a=0};
	/int sysmask_tab\[\]/ {a=1};
	a > 0 {print};
	/NR_sysmasks/ {exit}' linux/sysmask.c >>masktab.c


